.TH md5 n 4.1 "Tcl-Extensions"
.HS md5 tcl
.BS
.SH NAME
md5 \- manipulate md5 message digests
.SH SYNOPSIS
\fBmd5\fI ?-log2base log2base? -string string\fR
.br
or
.br
\fBmd5\fI ?-log2base log2base? ?-copychan chanID? -chan chanID\fR
.br
or
.br
\fBmd5\fI -init\fR (returns descriptor)
.br
\fBmd5\fI -update descriptor ?-maxbytes n? ?-copychan chanID? -chan chanID\fR
.br
\fBmd5\fI ?-log2base log2base? -final descriptor\fR
.SH DESCRIPTION
.PP
Switches can be in any order.
.PP
Returns a md5 digest in base 2 ** log2base ascii representation.
log2base defaults to 4, i.e. hex representation.
.PP
.nf
       log2base   length   chars 
         1          128      01            (binary)
         2           64      0..3
         3           43      0...7         (octal)
         4           32      0..9a..f      (hex)
         5           26      0..9a..v      
         6           22      0..9a..zA..Z_, 
.fo
.PP
(The characters in the digest string have been chosen to be usable in 
filenames so that the md5 command can be used, for example, 
to digest URLs into shorter strings for filenames in a cache.)
.PP
In the -string version, returns md5 digest alone of string.
.PP
In the -chan version, returns list of 2 items: length of data
in chanID followed by md5 digest of all data in chanID.  ChanID is
identifier returned from "open" for example.  If -copychan is supplied,
will also copy all data from chanID to copychanID.
.PP
In the third form, -init returns a descriptor, -update can be called
any number of times with that descriptor and returns the number of
bytes read, and -final returns the result in the same form as the
standalone -chan.
